/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan;
import edu.kit.ipd.descartes.mm.adaptation.Parameter;
import edu.kit.ipd.descartes.mm.adaptation.Tactic;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Tactic</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.TacticImpl#getImplementedPlan <em>Implemented Plan</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.TacticImpl#getInputParams <em>Input Params</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.TacticImpl#getOutputParam <em>Output Param</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TacticImpl extends EntityImpl implements Tactic {
    /**
	 * The cached value of the '{@link #getImplementedPlan() <em>Implemented Plan</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getImplementedPlan()
	 * @generated
	 * @ordered
	 */
    protected AdaptationPlan implementedPlan;

    /**
	 * The cached value of the '{@link #getInputParams() <em>Input Params</em>}' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getInputParams()
	 * @generated
	 * @ordered
	 */
    protected EList<Parameter> inputParams;

    /**
	 * The cached value of the '{@link #getOutputParam() <em>Output Param</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getOutputParam()
	 * @generated
	 * @ordered
	 */
    protected Parameter outputParam;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected TacticImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationPackage.Literals.TACTIC;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public AdaptationPlan getImplementedPlan() {
		return implementedPlan;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetImplementedPlan(AdaptationPlan newImplementedPlan, NotificationChain msgs) {
		AdaptationPlan oldImplementedPlan = implementedPlan;
		implementedPlan = newImplementedPlan;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationPackage.TACTIC__IMPLEMENTED_PLAN, oldImplementedPlan, newImplementedPlan);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setImplementedPlan(AdaptationPlan newImplementedPlan) {
		if (newImplementedPlan != implementedPlan) {
			NotificationChain msgs = null;
			if (implementedPlan != null)
				msgs = ((InternalEObject)implementedPlan).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.TACTIC__IMPLEMENTED_PLAN, null, msgs);
			if (newImplementedPlan != null)
				msgs = ((InternalEObject)newImplementedPlan).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.TACTIC__IMPLEMENTED_PLAN, null, msgs);
			msgs = basicSetImplementedPlan(newImplementedPlan, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.TACTIC__IMPLEMENTED_PLAN, newImplementedPlan, newImplementedPlan));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Parameter> getInputParams() {
		if (inputParams == null) {
			inputParams = new EObjectResolvingEList<Parameter>(Parameter.class, this, AdaptationPackage.TACTIC__INPUT_PARAMS);
		}
		return inputParams;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Parameter getOutputParam() {
		if (outputParam != null && outputParam.eIsProxy()) {
			InternalEObject oldOutputParam = (InternalEObject)outputParam;
			outputParam = (Parameter)eResolveProxy(oldOutputParam);
			if (outputParam != oldOutputParam) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationPackage.TACTIC__OUTPUT_PARAM, oldOutputParam, outputParam));
			}
		}
		return outputParam;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Parameter basicGetOutputParam() {
		return outputParam;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setOutputParam(Parameter newOutputParam) {
		Parameter oldOutputParam = outputParam;
		outputParam = newOutputParam;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.TACTIC__OUTPUT_PARAM, oldOutputParam, outputParam));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdaptationPackage.TACTIC__IMPLEMENTED_PLAN:
				return basicSetImplementedPlan(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.TACTIC__IMPLEMENTED_PLAN:
				return getImplementedPlan();
			case AdaptationPackage.TACTIC__INPUT_PARAMS:
				return getInputParams();
			case AdaptationPackage.TACTIC__OUTPUT_PARAM:
				if (resolve) return getOutputParam();
				return basicGetOutputParam();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.TACTIC__IMPLEMENTED_PLAN:
				setImplementedPlan((AdaptationPlan)newValue);
				return;
			case AdaptationPackage.TACTIC__INPUT_PARAMS:
				getInputParams().clear();
				getInputParams().addAll((Collection<? extends Parameter>)newValue);
				return;
			case AdaptationPackage.TACTIC__OUTPUT_PARAM:
				setOutputParam((Parameter)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.TACTIC__IMPLEMENTED_PLAN:
				setImplementedPlan((AdaptationPlan)null);
				return;
			case AdaptationPackage.TACTIC__INPUT_PARAMS:
				getInputParams().clear();
				return;
			case AdaptationPackage.TACTIC__OUTPUT_PARAM:
				setOutputParam((Parameter)null);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.TACTIC__IMPLEMENTED_PLAN:
				return implementedPlan != null;
			case AdaptationPackage.TACTIC__INPUT_PARAMS:
				return inputParams != null && !inputParams.isEmpty();
			case AdaptationPackage.TACTIC__OUTPUT_PARAM:
				return outputParam != null;
		}
		return super.eIsSet(featureID);
	}

} //TacticImpl
