/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import edu.kit.ipd.descartes.core.impl.EntityImpl;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.WeightedMetric;
import edu.kit.ipd.descartes.mm.adaptation.WeightingFunction;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Weighting Function</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightingFunctionImpl#getWeightedMetrics <em>Weighted Metrics</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightingFunctionImpl#getWeightingFunctionImplementation <em>Weighting Function Implementation</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class WeightingFunctionImpl extends EntityImpl implements WeightingFunction {
    /**
	 * The cached value of the '{@link #getWeightedMetrics() <em>Weighted Metrics</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getWeightedMetrics()
	 * @generated
	 * @ordered
	 */
    protected EList<WeightedMetric> weightedMetrics;

    /**
	 * The default value of the '{@link #getWeightingFunctionImplementation() <em>Weighting Function Implementation</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getWeightingFunctionImplementation()
	 * @generated
	 * @ordered
	 */
    protected static final String WEIGHTING_FUNCTION_IMPLEMENTATION_EDEFAULT = "";

    /**
	 * The cached value of the '{@link #getWeightingFunctionImplementation() <em>Weighting Function Implementation</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getWeightingFunctionImplementation()
	 * @generated
	 * @ordered
	 */
    protected String weightingFunctionImplementation = WEIGHTING_FUNCTION_IMPLEMENTATION_EDEFAULT;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected WeightingFunctionImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationPackage.Literals.WEIGHTING_FUNCTION;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<WeightedMetric> getWeightedMetrics() {
		if (weightedMetrics == null) {
			weightedMetrics = new EObjectContainmentEList<WeightedMetric>(WeightedMetric.class, this, AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTED_METRICS);
		}
		return weightedMetrics;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public String getWeightingFunctionImplementation() {
		return weightingFunctionImplementation;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setWeightingFunctionImplementation(String newWeightingFunctionImplementation) {
		String oldWeightingFunctionImplementation = weightingFunctionImplementation;
		weightingFunctionImplementation = newWeightingFunctionImplementation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION, oldWeightingFunctionImplementation, weightingFunctionImplementation));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTED_METRICS:
				return ((InternalEList<?>)getWeightedMetrics()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTED_METRICS:
				return getWeightedMetrics();
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION:
				return getWeightingFunctionImplementation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTED_METRICS:
				getWeightedMetrics().clear();
				getWeightedMetrics().addAll((Collection<? extends WeightedMetric>)newValue);
				return;
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION:
				setWeightingFunctionImplementation((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTED_METRICS:
				getWeightedMetrics().clear();
				return;
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION:
				setWeightingFunctionImplementation(WEIGHTING_FUNCTION_IMPLEMENTATION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTED_METRICS:
				return weightedMetrics != null && !weightedMetrics.isEmpty();
			case AdaptationPackage.WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION:
				return WEIGHTING_FUNCTION_IMPLEMENTATION_EDEFAULT == null ? weightingFunctionImplementation != null : !WEIGHTING_FUNCTION_IMPLEMENTATION_EDEFAULT.equals(weightingFunctionImplementation);
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (weightingFunctionImplementation: ");
		result.append(weightingFunctionImplementation);
		result.append(')');
		return result.toString();
	}

} //WeightingFunctionImpl
