/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.ExplicitDescription;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Control Flow Variable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ControlFlowVariableImpl#getExplicitDescription <em>Explicit Description</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ControlFlowVariableImpl extends ModelVariableImpl implements ControlFlowVariable {
	/**
	 * The default value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected static final ModelVariableCharacterizationType CHARACTERIZATION_EDEFAULT = ModelVariableCharacterizationType.EMPIRICAL;

	/**
	 * The cached value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected ModelVariableCharacterizationType characterization = CHARACTERIZATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExplicitDescription() <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExplicitDescription()
	 * @generated
	 * @ordered
	 */
	protected RandomVariable explicitDescription;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ControlFlowVariableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.CONTROL_FLOW_VARIABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelVariableCharacterizationType getCharacterization() {
		return characterization;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCharacterization(ModelVariableCharacterizationType newCharacterization) {
		ModelVariableCharacterizationType oldCharacterization = characterization;
		characterization = newCharacterization == null ? CHARACTERIZATION_EDEFAULT : newCharacterization;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__CHARACTERIZATION, oldCharacterization, characterization));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomVariable getExplicitDescription() {
		return explicitDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExplicitDescription(RandomVariable newExplicitDescription, NotificationChain msgs) {
		RandomVariable oldExplicitDescription = explicitDescription;
		explicitDescription = newExplicitDescription;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION, oldExplicitDescription, newExplicitDescription);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExplicitDescription(RandomVariable newExplicitDescription) {
		if (newExplicitDescription != explicitDescription) {
			NotificationChain msgs = null;
			if (explicitDescription != null)
				msgs = ((InternalEObject)explicitDescription).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION, null, msgs);
			if (newExplicitDescription != null)
				msgs = ((InternalEObject)newExplicitDescription).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION, null, msgs);
			msgs = basicSetExplicitDescription(newExplicitDescription, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION, newExplicitDescription, newExplicitDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION:
				return basicSetExplicitDescription(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__CHARACTERIZATION:
				return getCharacterization();
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION:
				return getExplicitDescription();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__CHARACTERIZATION:
				setCharacterization((ModelVariableCharacterizationType)newValue);
				return;
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION:
				setExplicitDescription((RandomVariable)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__CHARACTERIZATION:
				setCharacterization(CHARACTERIZATION_EDEFAULT);
				return;
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION:
				setExplicitDescription((RandomVariable)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__CHARACTERIZATION:
				return characterization != CHARACTERIZATION_EDEFAULT;
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE__EXPLICIT_DESCRIPTION:
				return explicitDescription != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (characterization: ");
		result.append(characterization);
		result.append(')');
		return result.toString();
	}

} //ControlFlowVariableImpl
