/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository;

import edu.kit.ipd.descartes.core.Entity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Assembly Context</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext#getEncapsulatedComponent <em>Encapsulated Component</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyContext()
 * @model
 * @generated
 */
public interface AssemblyContext extends Entity {
	/**
	 * Returns the value of the '<em><b>Parent Structure</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getAssemblyContexts <em>Assembly Contexts</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent Structure</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent Structure</em>' container reference.
	 * @see #setParentStructure(ComposedStructure)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyContext_ParentStructure()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getAssemblyContexts
	 * @model opposite="assemblyContexts" required="true" transient="false"
	 * @generated
	 */
	ComposedStructure getParentStructure();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext#getParentStructure <em>Parent Structure</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent Structure</em>' container reference.
	 * @see #getParentStructure()
	 * @generated
	 */
	void setParentStructure(ComposedStructure value);

	/**
	 * Returns the value of the '<em><b>Encapsulated Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Encapsulated Component</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Encapsulated Component</em>' reference.
	 * @see #setEncapsulatedComponent(RepositoryComponent)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getAssemblyContext_EncapsulatedComponent()
	 * @model required="true"
	 * @generated
	 */
	RepositoryComponent getEncapsulatedComponent();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext#getEncapsulatedComponent <em>Encapsulated Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Encapsulated Component</em>' reference.
	 * @see #getEncapsulatedComponent()
	 * @generated
	 */
	void setEncapsulatedComponent(RepositoryComponent value);

} // AssemblyContext
