/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Branch Action</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchAction#getBranches <em>Branches</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchAction#getBranchProbabilities <em>Branch Probabilities</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getBranchAction()
 * @model
 * @generated
 */
public interface BranchAction extends AbstractAction {
	/**
	 * Returns the value of the '<em><b>Branches</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ComponentInternalBehavior}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Branches</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Branches</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getBranchAction_Branches()
	 * @model containment="true"
	 * @generated
	 */
	EList<ComponentInternalBehavior> getBranches();

	/**
	 * Returns the value of the '<em><b>Branch Probabilities</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchProbabilities#getBranchAction <em>Branch Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Branch Probabilities</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Branch Probabilities</em>' containment reference.
	 * @see #setBranchProbabilities(BranchProbabilities)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getBranchAction_BranchProbabilities()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchProbabilities#getBranchAction
	 * @model opposite="branchAction" containment="true" required="true"
	 * @generated
	 */
	BranchProbabilities getBranchProbabilities();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchAction#getBranchProbabilities <em>Branch Probabilities</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Branch Probabilities</em>' containment reference.
	 * @see #getBranchProbabilities()
	 * @generated
	 */
	void setBranchProbabilities(BranchProbabilities value);

} // BranchAction
