/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile.impl;

import edu.kit.ipd.descartes.core.CorePackage;
import edu.kit.ipd.descartes.core.Entity;
import edu.kit.ipd.descartes.core.NamedElement;
import edu.kit.ipd.descartes.identifier.Identifier;
import edu.kit.ipd.descartes.identifier.IdentifierPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Signature;

import edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting;
import edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>System Call User Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getId <em>Id</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getName <em>Name</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getProvidingRole <em>Providing Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getSignature <em>Signature</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.SystemCallUserActionImpl#getInputParameterSettings <em>Input Parameter Settings</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SystemCallUserActionImpl extends AbstractUserActionImpl implements SystemCallUserAction {
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getProvidingRole() <em>Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidingRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingRole providingRole;

	/**
	 * The cached value of the '{@link #getSignature() <em>Signature</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSignature()
	 * @generated
	 * @ordered
	 */
	protected Signature signature;

	/**
	 * The cached value of the '{@link #getInputParameterSettings() <em>Input Parameter Settings</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInputParameterSettings()
	 * @generated
	 * @ordered
	 */
	protected EList<CallParameterSetting> inputParameterSettings;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SystemCallUserActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return UsageProfilePackage.Literals.SYSTEM_CALL_USER_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId) {
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole getProvidingRole() {
		if (providingRole != null && providingRole.eIsProxy()) {
			InternalEObject oldProvidingRole = (InternalEObject)providingRole;
			providingRole = (InterfaceProvidingRole)eResolveProxy(oldProvidingRole);
			if (providingRole != oldProvidingRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE, oldProvidingRole, providingRole));
			}
		}
		return providingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole basicGetProvidingRole() {
		return providingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProvidingRole(InterfaceProvidingRole newProvidingRole) {
		InterfaceProvidingRole oldProvidingRole = providingRole;
		providingRole = newProvidingRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE, oldProvidingRole, providingRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signature getSignature() {
		if (signature != null && signature.eIsProxy()) {
			InternalEObject oldSignature = (InternalEObject)signature;
			signature = (Signature)eResolveProxy(oldSignature);
			if (signature != oldSignature) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE, oldSignature, signature));
			}
		}
		return signature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signature basicGetSignature() {
		return signature;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSignature(Signature newSignature) {
		Signature oldSignature = signature;
		signature = newSignature;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE, oldSignature, signature));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CallParameterSetting> getInputParameterSettings() {
		if (inputParameterSettings == null) {
			inputParameterSettings = new EObjectContainmentEList<CallParameterSetting>(CallParameterSetting.class, this, UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS);
		}
		return inputParameterSettings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				return ((InternalEList<?>)getInputParameterSettings()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__ID:
				return getId();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__NAME:
				return getName();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				if (resolve) return getProvidingRole();
				return basicGetProvidingRole();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				if (resolve) return getSignature();
				return basicGetSignature();
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				return getInputParameterSettings();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__ID:
				setId((String)newValue);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__NAME:
				setName((String)newValue);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				setProvidingRole((InterfaceProvidingRole)newValue);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				setSignature((Signature)newValue);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				getInputParameterSettings().clear();
				getInputParameterSettings().addAll((Collection<? extends CallParameterSetting>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__ID:
				setId(ID_EDEFAULT);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__NAME:
				setName(NAME_EDEFAULT);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				setProvidingRole((InterfaceProvidingRole)null);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				setSignature((Signature)null);
				return;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				getInputParameterSettings().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE:
				return providingRole != null;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__SIGNATURE:
				return signature != null;
			case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS:
				return inputParameterSettings != null && !inputParameterSettings.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Identifier.class) {
			switch (derivedFeatureID) {
				case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__ID: return IdentifierPackage.IDENTIFIER__ID;
				default: return -1;
			}
		}
		if (baseClass == NamedElement.class) {
			switch (derivedFeatureID) {
				case UsageProfilePackage.SYSTEM_CALL_USER_ACTION__NAME: return CorePackage.NAMED_ELEMENT__NAME;
				default: return -1;
			}
		}
		if (baseClass == Entity.class) {
			switch (derivedFeatureID) {
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Identifier.class) {
			switch (baseFeatureID) {
				case IdentifierPackage.IDENTIFIER__ID: return UsageProfilePackage.SYSTEM_CALL_USER_ACTION__ID;
				default: return -1;
			}
		}
		if (baseClass == NamedElement.class) {
			switch (baseFeatureID) {
				case CorePackage.NAMED_ELEMENT__NAME: return UsageProfilePackage.SYSTEM_CALL_USER_ACTION__NAME;
				default: return -1;
			}
		}
		if (baseClass == Entity.class) {
			switch (baseFeatureID) {
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: ");
		result.append(id);
		result.append(", name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //SystemCallUserActionImpl
